package com.fjhx.controller;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.base.R;
import com.fjhx.entity.EmailMailbox;
import com.fjhx.entity.EmailMailboxLink;
import com.fjhx.entity.EmailMessage;
import com.fjhx.service.IEmailMailboxLinkService;
import com.fjhx.service.IEmailMailboxService;
import com.fjhx.vo.GetMailboxMassageListVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zlj
 * @since 2022-12-20
 */
@RestController
@RequestMapping("/emailMailbox")
public class EmailMailboxController {

    @Autowired
    private IEmailMailboxService emailMailboxService;

    @Autowired
    private IEmailMailboxLinkService emailMailboxLinkService;

    /**
     * 获取邮箱文件夹列表
     */
    @GetMapping("/tree")
    public R tree(@RequestParam("email") String email) {
        List<JSONObject> emailMailboxList = emailMailboxService.getList(email);
        return R.ok(emailMailboxList);
    }

    /**
     * 编辑文件夹
     */
    @PostMapping("/add")
    public R add(@RequestBody EmailMailbox emailMailbox) {
        emailMailboxService.add(emailMailbox);
        return R.ok();
    }

    /**
     * 编辑文件夹
     */
    @PostMapping("/edit")
    public R edit(@RequestBody EmailMailbox emailMailbox) {
        emailMailboxService.edit(emailMailbox);
        return R.ok();
    }

    /**
     * 删除文件夹
     */
    @GetMapping("/delete")
    public R delete(@RequestParam("emailMailboxId") Long emailMailboxId) {
        emailMailboxService.delete(emailMailboxId);
        return R.ok();
    }

    /**
     * 获取邮箱中的邮件列表
     */
    @GetMapping("getMassageList")
    public R getMassageList(GetMailboxMassageListVo vo) {
        Page<EmailMessage> emailMessageExList = emailMailboxLinkService.getMassageList(vo);
        return R.ok(emailMessageExList);
    }

    /**
     * 绑定邮件
     */
    @PostMapping("bindMassage")
    public R bindMassage(@RequestBody EmailMailboxLink emailMailboxLink) {
        emailMailboxLinkService.bindMassage(emailMailboxLink);
        return R.ok();
    }

    /**
     * 绑定邮件
     */
    @PostMapping("unbindMassage")
    public R unbindMassage(@RequestBody EmailMailboxLink emailMailboxLink) {
        emailMailboxLinkService.unbindMassage(emailMailboxLink);
        return R.ok();
    }

}
