package com.fjhx.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.base.R;
import com.fjhx.entity.EmailMessage;
import com.fjhx.entity.EmailMessageAttachment;
import com.fjhx.service.IEmailMessageAttachmentService;
import com.fjhx.service.IEmailMessageContentService;
import com.fjhx.service.IEmailMessageService;
import com.fjhx.vo.GetEmailMessagePageVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zlj
 * @since 2022-12-21
 */
@RestController
@RequestMapping("/emailMessage")
public class EmailMessageController {

    @Autowired
    private IEmailMessageService emailMessageService;

    @Autowired
    private IEmailMessageContentService emailMessageContentService;

    @Autowired
    private IEmailMessageAttachmentService emailMessageAttachmentService;

    /**
     * 获取邮件分页信息
     */
    @GetMapping("/page")
    public R page(GetEmailMessagePageVo vo) {
        Page<EmailMessage> result = emailMessageService.getPage(vo);
        return R.ok(result);
    }

    /**
     * 删除邮件
     */
    @GetMapping("/delete")
    public R delete(@RequestParam("messageId") String messageId) {
        emailMessageService.delete(messageId);
        return R.ok();
    }

    /**
     * 获取邮件正文
     */
    @GetMapping("/content")
    public R content(@RequestParam String email, @RequestParam("messageId") String messageId) {
        String result = emailMessageContentService.getContent(email, messageId);
        return R.ok(result);
    }

    /**
     * 邮件附件列表
     */
    @GetMapping("/attachmentList")
    public R attachmentList(@RequestParam("messageId") String messageId) {
        List<EmailMessageAttachment> result = emailMessageAttachmentService.getAttachmentList(messageId);
        return R.ok(result);
    }

    /**
     * 下载附件
     */
    @GetMapping("/downloadAttachment")
    public R downloadAttachment(@RequestParam("email") String email,
                                @RequestParam("attachmentId") String attachmentId,
                                @RequestParam("path") String path) {
        emailMessageAttachmentService.downloadAttachment(email, attachmentId, path);
        return R.ok();
    }

}
