package com.fjhx.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.base.BaseEntity;
import com.fjhx.entity.EmailMailbox;
import com.fjhx.mapper.EmailMailboxMapper;
import com.fjhx.service.IEmailMailboxService;
import com.fjhx.utils.TreeUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zlj
 * @since 2022-12-20
 */
@Service
public class EmailMailboxServiceImpl extends ServiceImpl<EmailMailboxMapper, EmailMailbox> implements IEmailMailboxService {

    @Override
    public List<JSONObject> getList(String email) {
        List<EmailMailbox> list = list(q -> q
                .select(BaseEntity::getId, EmailMailbox::getParentId, EmailMailbox::getName)
                .eq(EmailMailbox::getEmail, email)
                .eq(EmailMailbox::getIsShow, true)
                .orderByAsc(EmailMailbox::getSort)
        );

        return TreeUtil.buildTree("name", list);
    }

    @Override
    public void add(EmailMailbox emailMailbox) {
        emailMailbox.setParentId(ObjectUtil.defaultIfNull(emailMailbox.getParentId(), 0L));
        emailMailbox.setIsShow(true);
        save(emailMailbox);
    }

    @Override
    public void edit(EmailMailbox emailMailbox) {
        updateById(emailMailbox);
    }

    @Override
    public void delete(Long emailMailboxId) {
        update(q -> q.eq(BaseEntity::getId, emailMailboxId).set(EmailMailbox::getIsShow, false));
    }

}
