package com.fjhx.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.entity.EmailMessageSendContent;
import com.fjhx.mapper.EmailMessageSendContentMapper;
import com.fjhx.service.IEmailMessageSendContentService;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 邮件发件信息 服务实现类
 * </p>
 *
 * @author zlj
 * @since 2023-01-13
 */
@Service
public class EmailMessageSendContentServiceImpl extends ServiceImpl<EmailMessageSendContentMapper, EmailMessageSendContent> implements IEmailMessageSendContentService {

    @Override
    public String getContent(Long messageSendId) {
        EmailMessageSendContent emailMessageSendContent = getOne(q -> q.eq(EmailMessageSendContent::getMessageSendId, messageSendId));
        Assert.notNull(emailMessageSendContent, "未找到正文");

        return emailMessageSendContent.getHtmlContent();
    }
}
